org.apache.cassandra.db.rows

## Interface BaseRowIterator<U extends Unfiltered>

All Superinterfaces:
  java.lang.AutoCloseable, CloseableIterator<U>, java.util.Iterator<U>

All Known Subinterfaces:
  RowIterator, UnfilteredRowIterator

All Known Implementing Classes:
  AbstractBTreePartition.SlicesIterator, AbstractSSTableIterator, AbstractUnfilteredRowIterator, BaseRows, FilteredRows, LazilyInitializedUnfilteredRowIterator, RowAndDeletionMergeIterator, SSTableIdentityIterator, SSTableIterator, SSTableReversedIterator, StreamReader.StreamDeserializer, UnfilteredRowIteratorWithLowerBound, WrappingUnfilteredRowIterator

    public interface BaseRowIterator<U extends Unfiltered>
    extends CloseableIterator<U>

A common interface for Row and Unfiltered, that permits sharing of the (majority) common methods and functionality

### Method Summary

All Methods Instance Methods Abstract Methods
`PartitionColumns` `columns()` A subset of the columns for the (static and regular) rows returned by this iterator.
`boolean` `isEmpty()` Returns whether the provided iterator has no data.
`boolean` `isReverseOrder()` Whether or not the rows returned by this iterator are in reversed clustering order.
`CFMetaData` `metadata()` The metadata for the table this iterator on.
`DecoratedKey` `partitionKey()` The partition key of the partition this in an iterator over.
`Row` `staticRow()` The static part corresponding to this partition (this can be an empty row but cannot be `null`).

### Methods inherited from interface org.apache.cassandra.utils.CloseableIterator

`close`

### Methods inherited from interface java.util.Iterator

`forEachRemaining, hasNext, next, remove`

### Method Detail

#### metadata

    CFMetaData metadata()

The metadata for the table this iterator on.

#### isReverseOrder

    boolean isReverseOrder()

Whether or not the rows returned by this iterator are in reversed clustering order.

#### columns

    PartitionColumns columns()

A subset of the columns for the (static and regular) rows returned by this iterator. Every row returned by this iterator must guarantee that it has only those columns.

#### partitionKey

    DecoratedKey partitionKey()

The partition key of the partition this in an iterator over.

#### staticRow

    Row staticRow()

The static part corresponding to this partition (this can be an empty row but cannot be `null`).

#### isEmpty

    boolean isEmpty()

Returns whether the provided iterator has no data.